//+------------------------------------------------------------------+
//|                                           Volatility quality.mq4 |
//|                                                                  |
//|                                                                  |
//| Volatility quality index originaly developed by                  |
//| Thomas Stridsman (August 2002 Active Trader Magazine)            |
//|                                                                  |
//| Price pre-smoothing and filter added by raff1410                 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  10
#property indicator_color1   Orchid
#property indicator_color2   Gold
#property indicator_color3   LimeGreen
#property indicator_color4   Red
#property indicator_color5   Red
#property indicator_color6   Cyan
#property indicator_color7   Yellow
#property indicator_color8   Teal
#property indicator_color9   Teal
#property indicator_color10  Teal
#property indicator_width3   2
#property indicator_width4   2
#property indicator_width5   2
#property indicator_style1   STYLE_DOT
#property indicator_style2   STYLE_DOT
#property indicator_style8   STYLE_DASHDOT
#property indicator_style9   STYLE_DASHDOT
#property indicator_style10  STYLE_DASHDOT

//
//
//
//
//

extern string TimeFrame            = "Current time frame";
extern int    PriceSmoothing       = 1;
extern int    PriceSmoothingMethod = MODE_LWMA;
extern int    MA1Period            = 9;
extern int    MA2Period            = 200;
extern double Filter               = 5;
extern int    BandsPeriod          = 20;
extern double BandsDeviations      = 2;
extern bool   Interpolate          = true;

extern bool   ArrowsOnFirstBar     = true;
extern bool   ShowLongTermMa       = true;

extern string note                 = "turn on Alert = true; turn off = false";
extern bool   alertsOn             = true;
extern bool   alertsOnSlope        = true;
extern bool   alertsOnFastSlowCross= true;
extern bool   alertsOnCurrent      = false;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = true;
extern bool   alertsEmail          = false;
extern bool   alertsNotify         = false;
extern string soundFile            = "alert2.wav";



//
//
//
//
//

double sumVqi[];
double sumVqida[];
double sumVqidb[];
double sumVqi1[];
double sumVqi2[];
double UpArrow[];
double DnArrow[];
double maBand[];
double upBand[];
double dnBand[];
double Vqi[];
double trend[];
double trend2[];

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(13);
      SetIndexBuffer(0, sumVqi1); 
      SetIndexBuffer(1, sumVqi2); 
      SetIndexBuffer(2, sumVqi); 
      SetIndexBuffer(3, sumVqida); 
      SetIndexBuffer(4, sumVqidb); 
      SetIndexBuffer(5, UpArrow); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,233);
      SetIndexBuffer(6, DnArrow); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,234);
      SetIndexBuffer(7, maBand);
      SetIndexBuffer(8, upBand);
      SetIndexBuffer(9, dnBand);
      SetIndexBuffer(10,Vqi); 
      SetIndexBuffer(11,trend);
      SetIndexBuffer(12,trend2);
      
      if (ShowLongTermMa)
      {
         SetIndexStyle(1,DRAW_LINE);  
      }
      else
      {
         SetIndexStyle(1,DRAW_NONE);
      } 
      
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         PriceSmoothing    = MathMax(PriceSmoothing,1);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" VQ nrp ("+PriceSmoothing+","+PriceSmoothingMethod+","+MA1Period+","+Filter+")");      
return(0);
}

int deinit() {  return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { sumVqi1[0] = MathMin(limit+1,Bars-1); return(0); }
         
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {         
     if (trend[limit] == -1) ClearPoint(limit,sumVqida,sumVqidb);
     for(i=limit; i>=0; i--)
     {
       if (i==(Bars-1))
       {
         Vqi[i]    = 0;
         sumVqi[i] = 0;
         continue;
       }
      
      //
      //
      //
      //
      //
      
         double cHigh  = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_HIGH ,i);
         double cLow   = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_LOW  ,i);
         double cOpen  = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_OPEN ,i);
         double cClose = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_CLOSE,i);
         double pClose = iMA(NULL,0,PriceSmoothing,0,PriceSmoothingMethod,PRICE_CLOSE,i+1);
         
         double trueRange = MathMax(cHigh,pClose)-MathMin(cLow,pClose);
         double     range = cHigh-cLow;
      
            if (range != 0 && trueRange!=0)
               double vqi = ((cClose-pClose)/trueRange + (cClose-cOpen)/range)*0.5;
            else      vqi = Vqi[i+1];

      //
      //
      //
      //
      //
         
         Vqi[i]      = MathAbs(vqi)*(cClose-pClose+cClose-cOpen)*0.5;
         sumVqi[i]   = sumVqi[i+1]+Vqi[i];
         sumVqida[i] = EMPTY_VALUE;
         sumVqidb[i] = EMPTY_VALUE;
         if (Filter > 0.0) if (MathAbs(sumVqi[i]-sumVqi[i+1]) < Filter*Point*MathPow(10,Digits%2)) sumVqi[i] = sumVqi[i+1];
      
      //
      //
      //
      //
      //
      
      trend[i] = trend[i+1];
         if (sumVqi[i] > sumVqi[i+1]) trend[i] =  1;
         if (sumVqi[i] < sumVqi[i+1]) trend[i] = -1;
         if (trend[i] == -1) PlotPoint(i,sumVqida,sumVqidb,sumVqi);
         
         UpArrow[i] = EMPTY_VALUE; 
         DnArrow[i] = EMPTY_VALUE;
         if (trend[i] != trend[i+1])
         if (trend[i] == 1)
               UpArrow[i] = sumVqi[i+1] - (Ask - Bid);     
         else  DnArrow[i] = sumVqi[i+1] + (Ask - Bid);
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      if (MA1Period > 1) sumVqi1[i] = iMAOnArray(sumVqi,0,MA1Period,0,MODE_SMA,i);
      if (MA2Period > 1) sumVqi2[i] = iMAOnArray(sumVqi,0,MA2Period,0,MODE_SMA,i);
      maBand[i] = iBandsOnArray(sumVqi,0,BandsPeriod,BandsDeviations,0,MODE_MAIN, i);
      upBand[i] = iBandsOnArray(sumVqi,0,BandsPeriod,BandsDeviations,0,MODE_UPPER,i);
      dnBand[i] = iBandsOnArray(sumVqi,0,BandsPeriod,BandsDeviations,0,MODE_LOWER,i);
      trend2[i] = trend2[i+1];
      if (sumVqi[i]>sumVqi2[i]) trend2[i] = 1;
      if (sumVqi[i]<sumVqi2[i]) trend2[i] =-1; 
   }
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   int shift = -1; if (ArrowsOnFirstBar) shift=1;
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend[limit] == -1) ClearPoint(limit,sumVqida,sumVqidb);
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
       int x = iBarShift(NULL,timeFrame,Time[i+shift]); 
          sumVqi1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,0,y);
          sumVqi2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,1,y);
          sumVqi[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,2,y);
          sumVqida[i] = EMPTY_VALUE;
          sumVqidb[i] = EMPTY_VALUE;
          maBand[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,7,y);
          upBand[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,8,y);
          dnBand[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,9,y);
          trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,11,y);
          trend2[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,12,y);
       if (x!=y)
       {
          UpArrow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,5,y);
          DnArrow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceSmoothing,PriceSmoothingMethod,MA1Period,MA2Period,Filter,BandsPeriod,BandsDeviations,6,y);
       }
          //
          //
          //
          //
          //
       
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int k = 1; k < n; k++)
             {
                sumVqi1[i+k] = sumVqi1[i] + (sumVqi1[i+n] - sumVqi1[i]) * k/n;
                sumVqi2[i+k] = sumVqi2[i] + (sumVqi2[i+n] - sumVqi2[i]) * k/n;
                sumVqi[i+k]  = sumVqi[i]  + (sumVqi[i+n]  - sumVqi[i])  * k/n;
                maBand[i+k]  = maBand[i]  + (maBand[i+n]  - maBand[i])  * k/n;
                upBand[i+k]  = upBand[i]  + (upBand[i+n]  - upBand[i])  * k/n;
                dnBand[i+k]  = dnBand[i]  + (dnBand[i+n]  - dnBand[i])  * k/n;
             }                      
    }
    for (i=limit;i>=0; i--) if (trend[i] == -1) PlotPoint(i,sumVqida,sumVqidb,sumVqi);   
    manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(time1,mess1,whichBar," sloping up");
            if (trend[whichBar] ==-1) doAlert(time1,mess1,whichBar," sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnFastSlowCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] == 1) doAlert(time2,mess2,whichBar," Fast VQ crossing Slow VQ up");
            if (trend2[whichBar] ==-1) doAlert(time2,mess2,whichBar," Fast VQ crossing Slow VQ down");
         }               
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," VQ ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," VQ "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


